#---
# Excerpted from "The ThoughtWorks Anthology 2",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/twa2 for more book information.
#---
require 'attribute-driven' # gem install attribute-driven
# http://rubygems.org/gems/attribute-driven

class BlogPost
  include AttributeDriven
  attributes :title, :updated_at, :content # boiler plate generated

  def current_month?
    today = Time.now
    @updated_at.year == today.year && @updated_at.month == today.month
  end
  def truncated_content(word_limit = 100)
    # ...
  end
end

class BlogAuthor
  include AttributeDriven
  attributes :name, :email # boiler plate generated

  def anonymous?
    @name.empty? && @email.empty?
  end
  def display
    return 'Unknown' if anonymous?
    @name || @email
  end
end

now = Time.now
blog_post1 = BlogPost.new(:title => 'Some Title', :updated_at => now, :content => 'some content')
blog_post2 = BlogPost.new(:title => 'Some Title', :updated_at => now, :content => 'some content')
puts blog_post1 == blog_post2 #=> true
puts blog_post1.current_month? #=> true
puts blog_post1.title #=> Some Title

blog_author1 = BlogAuthor.new(:name => 'Some Name', :email => 'test@test.com')
blog_author2 = BlogAuthor.new(:name => 'Some Name', :email => 'test@test.com')
puts blog_author1 == blog_author2 #=> true
puts blog_author1.anonymous? #=> false
puts blog_author1.name #=> Some Name
